# CatalogApi

All URIs are relative to *https://api.ingrammicro.com:443/sandbox/resellers/v5*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getV5CatalogProductsearch**](CatalogApi.md#getV5CatalogProductsearch) | **GET** /catalog | Search product catalog
[**multiSKUPriceAndStock**](CatalogApi.md#multiSKUPriceAndStock) | **POST** /catalog/priceandavailability | Find availability of upto 50 SKUs

<a name="getV5CatalogProductsearch"></a>
# **getV5CatalogProductsearch**
> ProductSearchResponse getV5CatalogProductsearch(customerNumber, isoCountryCode, partNumber)

Search product catalog

Search product catalog using Ingram part numbers, vendor/manufacturer part numbers, customer part numbers or UPC. Use this endpoint to find the ingrampartnumber using vendorpartnumber or UPC.  - PartNumber field is capable of searching Ingram part numbers, vendor/manufacturer part numbers, customer part numbers or UPC.  *NOTE: isoCountryCode and customerNumber is mandatory.* 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.CatalogApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: application
OAuth application = (OAuth) defaultClient.getAuthentication("application");
application.setAccessToken("YOUR ACCESS TOKEN");

CatalogApi apiInstance = new CatalogApi();
String customerNumber = "20-222222"; // String | Your unique Ingram Micro customer number
String isoCountryCode = "US"; // String | 2 chars country code
String partNumber = "1AQ821"; // String | Part Number can be ingram part number or vendor part number or customer part number or UPC
try {
    ProductSearchResponse result = apiInstance.getV5CatalogProductsearch(customerNumber, isoCountryCode, partNumber);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling CatalogApi#getV5CatalogProductsearch");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerNumber** | **String**| Your unique Ingram Micro customer number | [default to 20-222222]
 **isoCountryCode** | **String**| 2 chars country code | [default to US]
 **partNumber** | **String**| Part Number can be ingram part number or vendor part number or customer part number or UPC | [default to 1AQ821]

### Return type

[**ProductSearchResponse**](ProductSearchResponse.md)

### Authorization

[application](../README.md#application)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="multiSKUPriceAndStock"></a>
# **multiSKUPriceAndStock**
> PriceAndAvailabilityResponse multiSKUPriceAndStock(body)

Find availability of upto 50 SKUs

Please use this end-point to find the price and availability of up to 50 SKUs while placing an order. This endpoint helps to confirm the details just prior to placing a real-time call.  This endpoint is not for refreshing the full catalog with availability and pricing information. We are applying rate-limits on this endpoint and continuous cyclical calls will start erroring out. Customers that perform this activity may lose access to the endpoint.  For the full catalog refresh, we can provide a Price and Inventory file in flat file format, which can be obtained through FTP download. Please contact your sales rep for details.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.CatalogApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: application
OAuth application = (OAuth) defaultClient.getAuthentication("application");
application.setAccessToken("YOUR ACCESS TOKEN");

CatalogApi apiInstance = new CatalogApi();
PriceAndAvailabilityRequest body = new PriceAndAvailabilityRequest(); // PriceAndAvailabilityRequest | 
try {
    PriceAndAvailabilityResponse result = apiInstance.multiSKUPriceAndStock(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling CatalogApi#multiSKUPriceAndStock");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**PriceAndAvailabilityRequest**](PriceAndAvailabilityRequest.md)|  | [optional]

### Return type

[**PriceAndAvailabilityResponse**](PriceAndAvailabilityResponse.md)

### Authorization

[application](../README.md#application)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

