/*
 * Product Catalog APIs
 * Ingram Micro product catalog API for requesting price and availability of SKUs in real time.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.PriceAndAvailabilityRequest;
import io.swagger.client.model.PriceAndAvailabilityResponse;
import io.swagger.client.model.ProductSearchResponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CatalogApi {
    private ApiClient apiClient;

    public CatalogApi() {
        this(Configuration.getDefaultApiClient());
    }

    public CatalogApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getV5CatalogProductsearch
     * @param customerNumber Your unique Ingram Micro customer number (required)
     * @param isoCountryCode 2 chars country code (required)
     * @param partNumber Part Number can be ingram part number or vendor part number or customer part number or UPC (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getV5CatalogProductsearchCall(String customerNumber, String isoCountryCode, String partNumber, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/catalog";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (customerNumber != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("customerNumber", customerNumber));
        if (isoCountryCode != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("isoCountryCode", isoCountryCode));
        if (partNumber != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("partNumber", partNumber));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "application" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getV5CatalogProductsearchValidateBeforeCall(String customerNumber, String isoCountryCode, String partNumber, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'customerNumber' is set
        if (customerNumber == null) {
            throw new ApiException("Missing the required parameter 'customerNumber' when calling getV5CatalogProductsearch(Async)");
        }
        // verify the required parameter 'isoCountryCode' is set
        if (isoCountryCode == null) {
            throw new ApiException("Missing the required parameter 'isoCountryCode' when calling getV5CatalogProductsearch(Async)");
        }
        // verify the required parameter 'partNumber' is set
        if (partNumber == null) {
            throw new ApiException("Missing the required parameter 'partNumber' when calling getV5CatalogProductsearch(Async)");
        }
        
        com.squareup.okhttp.Call call = getV5CatalogProductsearchCall(customerNumber, isoCountryCode, partNumber, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Search product catalog
     * Search product catalog using Ingram part numbers, vendor/manufacturer part numbers, customer part numbers or UPC. Use this endpoint to find the ingrampartnumber using vendorpartnumber or UPC.  - PartNumber field is capable of searching Ingram part numbers, vendor/manufacturer part numbers, customer part numbers or UPC.  *NOTE: isoCountryCode and customerNumber is mandatory.* 
     * @param customerNumber Your unique Ingram Micro customer number (required)
     * @param isoCountryCode 2 chars country code (required)
     * @param partNumber Part Number can be ingram part number or vendor part number or customer part number or UPC (required)
     * @return ProductSearchResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProductSearchResponse getV5CatalogProductsearch(String customerNumber, String isoCountryCode, String partNumber) throws ApiException {
        ApiResponse<ProductSearchResponse> resp = getV5CatalogProductsearchWithHttpInfo(customerNumber, isoCountryCode, partNumber);
        return resp.getData();
    }

    /**
     * Search product catalog
     * Search product catalog using Ingram part numbers, vendor/manufacturer part numbers, customer part numbers or UPC. Use this endpoint to find the ingrampartnumber using vendorpartnumber or UPC.  - PartNumber field is capable of searching Ingram part numbers, vendor/manufacturer part numbers, customer part numbers or UPC.  *NOTE: isoCountryCode and customerNumber is mandatory.* 
     * @param customerNumber Your unique Ingram Micro customer number (required)
     * @param isoCountryCode 2 chars country code (required)
     * @param partNumber Part Number can be ingram part number or vendor part number or customer part number or UPC (required)
     * @return ApiResponse&lt;ProductSearchResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProductSearchResponse> getV5CatalogProductsearchWithHttpInfo(String customerNumber, String isoCountryCode, String partNumber) throws ApiException {
        com.squareup.okhttp.Call call = getV5CatalogProductsearchValidateBeforeCall(customerNumber, isoCountryCode, partNumber, null, null);
        Type localVarReturnType = new TypeToken<ProductSearchResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Search product catalog (asynchronously)
     * Search product catalog using Ingram part numbers, vendor/manufacturer part numbers, customer part numbers or UPC. Use this endpoint to find the ingrampartnumber using vendorpartnumber or UPC.  - PartNumber field is capable of searching Ingram part numbers, vendor/manufacturer part numbers, customer part numbers or UPC.  *NOTE: isoCountryCode and customerNumber is mandatory.* 
     * @param customerNumber Your unique Ingram Micro customer number (required)
     * @param isoCountryCode 2 chars country code (required)
     * @param partNumber Part Number can be ingram part number or vendor part number or customer part number or UPC (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getV5CatalogProductsearchAsync(String customerNumber, String isoCountryCode, String partNumber, final ApiCallback<ProductSearchResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getV5CatalogProductsearchValidateBeforeCall(customerNumber, isoCountryCode, partNumber, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProductSearchResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for multiSKUPriceAndStock
     * @param body  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call multiSKUPriceAndStockCall(PriceAndAvailabilityRequest body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/catalog/priceandavailability";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "application" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call multiSKUPriceAndStockValidateBeforeCall(PriceAndAvailabilityRequest body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = multiSKUPriceAndStockCall(body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Find availability of upto 50 SKUs
     * Please use this end-point to find the price and availability of up to 50 SKUs while placing an order. This endpoint helps to confirm the details just prior to placing a real-time call.  This endpoint is not for refreshing the full catalog with availability and pricing information. We are applying rate-limits on this endpoint and continuous cyclical calls will start erroring out. Customers that perform this activity may lose access to the endpoint.  For the full catalog refresh, we can provide a Price and Inventory file in flat file format, which can be obtained through FTP download. Please contact your sales rep for details.
     * @param body  (optional)
     * @return PriceAndAvailabilityResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PriceAndAvailabilityResponse multiSKUPriceAndStock(PriceAndAvailabilityRequest body) throws ApiException {
        ApiResponse<PriceAndAvailabilityResponse> resp = multiSKUPriceAndStockWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * Find availability of upto 50 SKUs
     * Please use this end-point to find the price and availability of up to 50 SKUs while placing an order. This endpoint helps to confirm the details just prior to placing a real-time call.  This endpoint is not for refreshing the full catalog with availability and pricing information. We are applying rate-limits on this endpoint and continuous cyclical calls will start erroring out. Customers that perform this activity may lose access to the endpoint.  For the full catalog refresh, we can provide a Price and Inventory file in flat file format, which can be obtained through FTP download. Please contact your sales rep for details.
     * @param body  (optional)
     * @return ApiResponse&lt;PriceAndAvailabilityResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PriceAndAvailabilityResponse> multiSKUPriceAndStockWithHttpInfo(PriceAndAvailabilityRequest body) throws ApiException {
        com.squareup.okhttp.Call call = multiSKUPriceAndStockValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<PriceAndAvailabilityResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Find availability of upto 50 SKUs (asynchronously)
     * Please use this end-point to find the price and availability of up to 50 SKUs while placing an order. This endpoint helps to confirm the details just prior to placing a real-time call.  This endpoint is not for refreshing the full catalog with availability and pricing information. We are applying rate-limits on this endpoint and continuous cyclical calls will start erroring out. Customers that perform this activity may lose access to the endpoint.  For the full catalog refresh, we can provide a Price and Inventory file in flat file format, which can be obtained through FTP download. Please contact your sales rep for details.
     * @param body  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call multiSKUPriceAndStockAsync(PriceAndAvailabilityRequest body, final ApiCallback<PriceAndAvailabilityResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = multiSKUPriceAndStockValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PriceAndAvailabilityResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
